package com.djorda.weatherprediction.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;


/**
 * Represents a triangle that is shaped by 3 <code>Points</code>. It contains 3 semiplanes
 * generated by the union between 2 points, pointA and pointB, that shape a LinearEquation and the parallel linear equation
 * that contains the other point of the triangle, pointC.
 * 
 * @author Damian Jorda
 * @since 1.0
 * @see Point
 * @see LinearEquation
 * @see SemiPlane
 */
public class Triangle implements IContainer{
    
    /**
     * Calculated manually, don't know how to do it automatically
     */
    private static final double MAX_PERIMETER = 6262.29d;

    /**
     * List of points that shape to triangle
     * 
     * @since 1.0
     */
    private List<Point> points;

    /**
     * semi planes that the intersection of all of them forms the triangle 
     * @since 1.0
     */
    private List<SemiPlane> semiPlanes;

    /**
     * center Point of the triangle
     * @since 1.0
     */
    private Point center;

    /**
     * perimeter of the triangle
     * @since 1.0
     */
    private double perimeter;

    /**
     * Constructs and initializes a Triangle with 3 given <code>Points</code>
     * 
     * @see Point
     * 
     * @since 1.0
     */
    public Triangle(Point pointA, Point pointB, Point pointC){
        this.points = new ArrayList<>();
        this.semiPlanes = new ArrayList<>();
        this.points.add(pointA);
        this.points.add(pointB);
        this.points.add(pointC);
        calculateCenter();
        createSemiPlanes();
        calculatePerimeter();
    }

    private void calculatePerimeter() {
        this.perimeter = this.points.stream()
            .mapToDouble( point -> point.distanceTo(this.points.get(this.getNextPointIndex(point, 1))).doubleValue() )
            .sum();
    }

    /**
     * Calculate the coordinates for the center of the triangle using the following
     * equation <code>X=(Ax+Bx+Cx)/3</code> and <code>Y=(Ay+By+Cy)/3</code>.
     * 
     * @since 1.0
     */
    private void calculateCenter() {
        this.center = new Point(this.getCoordinateValue(Point::getX), this.getCoordinateValue(Point::getY));
    }

    /**
     * @param getter function to get double numbers to be added among them
     * @return the division between the sum for the given function and the quantity of points for the array 
     * that is always 3.
     * @since 1.0
     */
    private double getCoordinateValue(Function<Point,BigDecimal> getter) {
        return this.points.stream().map( getter ).mapToDouble( bigd -> bigd.doubleValue()).sum() / this.points.size();
    }

    /**
     * Generates the semiplanes of the triangle. Every semiplane is generated by 2 points to generate a LinearEquation
     * and the parallel LinearEquation that contains the other point of the triangle. So each triangle must have 3 semiplanes.
     * @since 1.0
     */
    private void createSemiPlanes() {
        this.points.forEach( point -> {
            Point otherPoint = this.points.get(this.getNextPointIndex(point, 1));
            Point oppositePoint = this.points.get(this.getNextPointIndex(point, 2));            
            LinearEquation linearEquation = new LinearEquation(point, otherPoint);
            LinearEquation parallelLinearEquation = linearEquation.getParallelLinearEquation(oppositePoint);       
            this.semiPlanes.add(new SemiPlane(linearEquation, parallelLinearEquation));
        });
    }

    /**
     * Return the index of the point from the given point to the quatity of moves given.
     * <p>
     * If the moves are greater than the size of the points list it will start counting from the beginning.
     * 
     * @param point start point
     * @param moves quatity of moves from the given point
     * @return
     */
    private int getNextPointIndex(Point point, int moves) {
        int nextIndex = this.points.indexOf(point) + moves;
        while(nextIndex >= this.points.size()){
            nextIndex = nextIndex - this.points.size();
        }      
        return nextIndex;
    }

    /**
     * If all of the semiplanes of the triangle contains that point, the point belongs to the triangle
     * 
     * @param point point to check if is part of the triangle
     * @return if the point belongs to the triangle
     * 
     * @since 1.0
     */
    @Override
    public boolean belongs(Point point) {
        return this.semiPlanes.stream().allMatch( semiplane -> semiplane.belongs(point) );
    }

    /**
     * @return the point in the center of the triangle.
     * @since 1.0
     * @see Point
     */
    public Point getCenter(){
        return this.center;
    }

    /**
     * @param point to check if is in the middle of the triangle
     * @return true if the given point is in the center of the triangle
     * @since 1.0
     * @see Point
     */
    public boolean isCenter(Point point){
        return this.center.equals(point);
    }

    /**
     * @return if the current perimeter is the max perimeter available
     * @since 1.0
     */
    public boolean isMaxPerimeter(){
        return this.perimeter == MAX_PERIMETER;
    }

    /**
     * @return the perimeter of the triangle.
     * @since 1.0
     */
    public double getPerimeter() {
        return this.perimeter;
    }

}